<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">

<head>
	<title>Sensor Calibration</title>

	<link rel='stylesheet' type="text/css" href='../css/meti_merged.css'>

	<script src='../js/meti_merged.js'></script>
	<script src='../js/meti_utils.js'></script>

	<style>
		html {
			visibility: hidden;
		}

		.my_input {
			text-align: center;
		}
	</style>

</head>

<body>
	<div w3-include-html="meti_bst.html"></div>

	<div class="container">
		<div class="row">
			<main role="main" class="col-sm-12 col-md-12 col-lg-8 pt-2">
				<h5 class="p-1">Sensor Calibration Values</h5>
				<form id="formID">
					<div class="border border-primary p-2">
						<div class="mqtt_settings">
							<div class="form-group p-0 m-1 row">
								<label class="col-3 my_input" ></label>
								<label class="col-2 my_input" >Milli Volts</label>
								<label class="col-2 my_input" >Current</label>
								<label class="col-2 my_input" >Resistance</label>
								<div class="col-2 meti_loader m-1" id="loader_calibrate" style="width:1.5rem; height:1.5rem">
							</div>

							<!-- Zero Value -->
							<div class="form-group p-0 m-1 row">
								<label class="col-3 my_input" for="sel_zero">Zero</label>
								
								<input type="text" id="sel_zero" name="sel_zero"
									class="col-2 form-control form-control-sm my_input"
									data-validation-engine="validate[required] custom[integer], min[-9999], max[9999]">

								<input type="text" id="sel_zero1" name="sel_zero1"
									class="col-2 form-control form-control-sm my_input" readonly>

								<input type="text" id="sel_zero2" name="sel_zero2"
									class="col-2 form-control form-control-sm my_input" readonly>

								<button type="button" id="button_zero"
									class="col-2 btn btn-sm btn-danger ml-3">Calibrate</button>
							</div>

							<!-- Span Value -->
							<div class="form-group p-0 m-1 row">
								<label class="col-3 my_input" for="sel_span">Span</label>

								<input type="text" id="sel_span" name="sel_span"
									class="col-2 form-control form-control-sm my_input"
									data-validation-engine="validate[required] custom[integer], min[-9999], max[9999]">

								<input type="text" id="sel_span1" name="sel_span1"
									class="col-2 form-control form-control-sm my_input" readonly>

								<input type="text" id="sel_span2" name="sel_span2"
									class="col-2 form-control form-control-sm my_input" readonly>

								<button type="button" id="button_span"
									class="col-2 btn btn-sm btn-danger ml-3">Calibrate</button>
							</div>
						</div>

						<div class="col-sm-12 form-group row mt-4 mb-1">
							<button type="button" id="button_cancel"
								class="btn btn-warning col ml-4 mr-4">Cancel</button>
							<button type="button" id="button_save" class="btn btn-success col ml-4 mr-4">Save</button>
						</div>
					</div>
				</form>
			</main>
		</div>
</body>

</html>

<script>
	w3IncludeHTML();

	$(document).ready(function () {
		var ZERO_CAL_MIN = 370;
		var ZERO_CAL_MAX = 430;
		var SPAN_CAL_MIN = 1900;
		var SPAN_CAL_MAX = 2100;

		// display all items
		document.getElementsByTagName("html")[0].style.visibility = "visible";

		// setupSelects();

		// function setupSelects() {
		// 	//keep alive
		// 	dataArray = [0, 1, 2, 3]
		// 	for (idx = 0; idx < dataArray.length; idx++) {
		// 		var opt = $('<option></option>')
		// 			.val(dataArray[idx])
		// 			.addClass('dropdown-item')
		// 			.addClass('dd-item')
		// 			.text(dataArray[idx]);

		// 		$("#sel_decimals").append(opt);
		// 	}
		// }

		$("#button_save").on("click", function () {
			if ($("#formID").validationEngine('validate')) {
				var r = confirm("Save Sensor Calibration configuration?");
				if (r == true) {
					save_config();
				}
			}
		});

		$("#button_cancel").on("click", function () {
			document.location.href = "index.html";
		});

		function load_form_data() {
			$("#packet_version").val(g_sensorScaling_db.pkt_ver);
			$("#sel_zero").val(g_sensorScaling_db.calibratedZero);
			$("#sel_span").val(g_sensorScaling_db.calibratedSpan);
		}

		function save_config() {
			var debug = 0;

			g_sensorScaling_db.calibratedZero = $("#sel_zero").val();
			g_sensorScaling_db.calibratedSpan = $("#sel_span").val();

			var url = "/updateSensorScaling";
			var type = 'POST';
			var data = {
				sensorScaling: JSON.stringify(g_sensorScaling_db)
			};

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (response) {
					if (debug == 1) {
						console.log(response);
					}
					else {
						// console.log(js_response);
						var result = response.result;

						if (result == 1) {
							alert(response.message);
						}
						else if (result == 0) {
							alert(response.message);
						}
					}
				},
				error: function (jqXHR, exception, response) {
					alert('POST Error!');
				}
			});
		}

		$("#button_zero").on("click", function () {
			var obj = $(this);
			enableDisable(obj, false);

			calibrate_values(obj);  //zero calibration is 1
		});

		$("#button_span").on("click", function () {
			var obj = $(this);
			enableDisable(obj, false);

			calibrate_values(obj); //span calibration is 2
		});

		function enableDisable(obj, isEnable) {
			if (isEnable == false) {
				$(obj).removeClass('btn-danger btn-primary btn-success')
					.addClass('btn-primary')
					.html('Wait...')

				$(".btn").attr("disabled", "disabled");
			} else {
				$(obj).removeClass('btn-danger btn-primary btn-success')
					.html('Calibrate');

				sel_zero = $("#sel_zero").val();
				sel_span = $("#sel_span").val();

				if (sel_zero <= ZERO_CAL_MIN || sel_zero >= ZERO_CAL_MAX) {
					$("#button_zero").addClass("btn-danger");
				} else {
					$("#button_zero").addClass("btn-success");
				}

				if (sel_span <= SPAN_CAL_MIN || sel_span >= SPAN_CAL_MAX) {
					$("#button_span").addClass("btn-danger");
				} else {
					$("#button_span").addClass("btn-success");
				}

				$(".btn").removeAttr("disabled");
			}
		}

		function calibrate_values(obj) {
			var debug = 0;
			var calibrateId = 0;

			if ($(obj).attr('id') == "button_zero") {
				calibrateId = 1;
			} if ($(obj).attr('id') == "button_span") {
				calibrateId = 2;
			}

			var url = "/calibrateSensor";
			var type = 'POST';
			var data = {
				calibrateId: calibrateId
			};

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (response) {
					if (debug == 1) {
						console.log(response);
					}
					else {
						// console.log(js_response);
						var result = response.result;

						if (result == 1) {
							if ($(obj).attr('id') == "button_zero") {
								//Zero calibration
								setTimeout(function () {
									get_calibrated_values(obj)
								}, 1000);
							} else {
								//Span calibration
								setTimeout(function () {
									get_calibrated_values(obj);
								}, 5000);
							}
						}
						else if (result == 0) {
							alert(response.message);
						}
					}
				},
				error: function (jqXHR, exception, response) {
					alert('POST Error!');
				}
			});
		}

		function get_calibrated_values(obj) {
			var debug = 0;
			var calibrateId = 0;

			if ($(obj).attr('id') == "button_zero") {
				calibrateId = 1;
			} if ($(obj).attr('id') == "button_span") {
				calibrateId = 2;
			}

			var url = "/getcalibratedValues";
			var type = 'POST';
			var data = {
				calibrateId: calibrateId
			};

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (response) {
					$("#loader_calibrate").css("display", "none");					
					if (debug == 1) {
						console.log(response);
					}
					else {
						// console.log(js_response);
						var result = response.result;

						if (result == 1) {
							if ($(obj).attr('id') == "button_zero") {
								//Zero calibration
								$("#sel_zero").val(response.mv);
								$("#sel_zero1").val(response.idac);
								$("#sel_zero2").val(response.res);
							} else {
								//Span calibration
								$("#sel_span").val(response.mv);
								$("#sel_span1").val(response.idac);
								$("#sel_span2").val(response.res);
							}
						}
						else if (result == 0) {
							alert(response.message);
						}
					}
					enableDisable(obj, true);
				},
				error: function (jqXHR, exception, response) {
					$("#loader_calibrate").css("display", "none");					
					alert('POST Error!');
					enableDisable(obj, true);
				}
			});
		}

		function noSensorData(response) {
			console.log("POST Error...")
		}

		function updateDevicesParams(response) {
			$("#sel_clientId").val(response.dev_id);
		}
		//********* Call all start up functions after this line *******//

		setTimeout(function () {
			getDeviceParams(updateDevicesParams, noSensorData);
		}, 500);

		setTimeout(function () {
			readSensorScalingFromFS(load_form_data);
		}, 750);

		$("#formID").validationEngine();
	});

</script>